diff --git a/.prev_CMakeLists.txt b/.prev_CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..4afe57df50f7cd595429905af2a6a77f493acfb7
--- /dev/null
+++ b/.prev_CMakeLists.txt
@@ -0,0 +1,19 @@
+# Generated from qtgamepad.pro.
+
+cmake_minimum_required(VERSION 3.15.0)
+
+project(QtGamepad
+    VERSION 6.0.0
+    DESCRIPTION "Qt Gamepad Libraries"
+    HOMEPAGE_URL "https://qt.io/"
+    LANGUAGES CXX C
+)
+
+find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core SET_ME_TO_SOMETHING_USEFUL)
+find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS SET_ME_TO_SOMETHING_USEFUL)
+
+if(NOT TARGET Qt::Gui)
+    message(NOTICE "Skipping the build as the condition \"TARGET Qt::Gui\" is not met.")
+    return()
+endif()
+qt_build_repo()
diff --git a/CMakeLists.txt b/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..1dc1e09faf4243521ca98d4c1c357099b1a67b32
--- /dev/null
+++ b/CMakeLists.txt
@@ -0,0 +1,21 @@
+# Generated from qtgamepad.pro.
+
+cmake_minimum_required(VERSION 3.15.0)
+
+project(QtGamepad
+    VERSION 6.0.0
+    DESCRIPTION "Qt Gamepad Libraries"
+    HOMEPAGE_URL "https://qt.io/"
+    LANGUAGES CXX C
+)
+
+# special case begin
+find_package(Qt6 ${PROJECT_VERSION} CONFIG REQUIRED COMPONENTS BuildInternals Core Gui Widgets)
+find_package(Qt6 ${PROJECT_VERSION} CONFIG OPTIONAL_COMPONENTS Quick QuickControls2 DeviceDiscoverySupport)
+# special case end
+
+if(NOT TARGET Qt::Gui)
+    message(NOTICE "Skipping the build as the condition \"TARGET Qt::Gui\" is not met.")
+    return()
+endif()
+qt_build_repo()
diff --git a/cmake/FindWrapSDL2.cmake b/cmake/FindWrapSDL2.cmake
new file mode 100644
index 0000000000000000000000000000000000000000..6b406eb0e48b6abc2a916133785d67e3a63939f8
--- /dev/null
+++ b/cmake/FindWrapSDL2.cmake
@@ -0,0 +1,13 @@
+include_guard(GLOBAL)
+
+find_package(SDL2 CONFIG QUIET)
+if (SDL2_FOUND AND TARGET SDL2::SDL2)
+  add_library(WrapSDL2::WrapSDL2 INTERFACE IMPORTED)
+  target_link_libraries(WrapSDL2::WrapSDL2 INTERFACE SDL2::SDL2)
+  set(WrapSDL2_FOUND TRUE)
+elseif(SDL2_FOUND AND SDL2_LIBRARIES AND SDL2_INCLUDE_DIRS)
+  add_library(WrapSDL2::WrapSDL2 INTERFACE IMPORTED)
+  target_link_libraries(WrapSDL2::WrapSDL2 INTERFACE ${SDL2_LIBRARIES})
+  target_include_directories(WrapSDL2::WrapSDL2 INTERFACE ${SDL2_INCLUDE_DIRS})
+  set(WrapSDL2_FOUND TRUE)
+endif()
diff --git a/coin/module_config.yaml b/coin/module_config.yaml
new file mode 100644
index 0000000000000000000000000000000000000000..2d433704113334f825de7a6f02fb4750a8321b12
--- /dev/null
+++ b/coin/module_config.yaml
@@ -0,0 +1,14 @@
+version: 1
+accept_configuration:
+  condition: property
+  property: host.os
+  equals_property: target.os
+
+build_instructions:
+  - !include "{{qt/qtbase}}/prepare_building_env.yaml"
+  - !include "{{qt/qtbase}}/cmake_module_build_instructions.yaml"
+
+test_instructions:
+  - type: EnvironmentVariable
+    variableName: Dummy
+    variableValue: dummy
diff --git a/configure.cmake b/configure.cmake
new file mode 100644
index 0000000000000000000000000000000000000000..53e3f1109aece59ced2fee6c3c730f62eaa536d3
--- /dev/null
+++ b/configure.cmake
@@ -0,0 +1,21 @@
+
+
+#### Inputs
+
+
+
+#### Libraries
+
+
+
+#### Tests
+
+
+
+#### Features
+
+
+qt_extra_definition("QT_VERSION_STR" "\"${PROJECT_VERSION}\"" PUBLIC)
+qt_extra_definition("QT_VERSION_MAJOR" ${PROJECT_VERSION_MAJOR} PUBLIC)
+qt_extra_definition("QT_VERSION_MINOR" ${PROJECT_VERSION_MINOR} PUBLIC)
+qt_extra_definition("QT_VERSION_PATCH" ${PROJECT_VERSION_PATCH} PUBLIC)
diff --git a/examples/CMakeLists.txt b/examples/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..f92a4149b3d68c447cf8ed78183d1b082e878ba3
--- /dev/null
+++ b/examples/CMakeLists.txt
@@ -0,0 +1,7 @@
+# Generated from examples.pro.
+
+qt_examples_build_begin()
+
+add_subdirectory(gamepad)
+
+qt_examples_build_end()
diff --git a/examples/gamepad/CMakeLists.txt b/examples/gamepad/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..684b86e498123bb631effd3b56afbd1367574779
--- /dev/null
+++ b/examples/gamepad/CMakeLists.txt
@@ -0,0 +1,11 @@
+# Generated from gamepad.pro.
+
+add_subdirectory(simple)
+if(TARGET Qt::Quick)
+    add_subdirectory(mouseItem)
+    add_subdirectory(keyNavigation)
+endif()
+if(TARGET Qt::Quick AND TARGET Qt::QuickControls2)
+    add_subdirectory(configureButtons)
+    add_subdirectory(quickGamepad)
+endif()
diff --git a/examples/gamepad/configureButtons/CMakeLists.txt b/examples/gamepad/configureButtons/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..4c1355b6cffc8612fb961cc73104cd883201e69f
--- /dev/null
+++ b/examples/gamepad/configureButtons/CMakeLists.txt
@@ -0,0 +1,48 @@
+# Generated from configureButtons.pro.
+
+cmake_minimum_required(VERSION 3.14)
+project(configureButtons LANGUAGES CXX)
+
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+set(CMAKE_AUTOUIC ON)
+
+set(INSTALL_EXAMPLEDIR "examples/gamepad/configureButtons")
+
+find_package(Qt6 COMPONENTS Core)
+find_package(Qt6 COMPONENTS Gui)
+find_package(Qt6 COMPONENTS Qml)
+find_package(Qt6 COMPONENTS Quick)
+find_package(Qt6 COMPONENTS Gamepad)
+
+add_qt_gui_executable(configureButtons
+    main.cpp
+)
+target_link_libraries(configureButtons PUBLIC
+    Qt::Core
+    Qt::Gamepad
+    Qt::Gui
+    Qt::Qml
+    Qt::Quick
+)
+
+
+# Resources:
+set(qml_resource_files
+    "main.qml"
+)
+
+qt6_add_resources(configureButtons "qml"
+    PREFIX
+        "/"
+    FILES
+        ${qml_resource_files}
+)
+
+install(TARGETS configureButtons
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/examples/gamepad/keyNavigation/CMakeLists.txt b/examples/gamepad/keyNavigation/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..a6042dfdd4434061984adcc53386a3f94642c6fc
--- /dev/null
+++ b/examples/gamepad/keyNavigation/CMakeLists.txt
@@ -0,0 +1,46 @@
+# Generated from keyNavigation.pro.
+
+cmake_minimum_required(VERSION 3.14)
+project(keyNavigation LANGUAGES CXX)
+
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+set(CMAKE_AUTOUIC ON)
+
+set(INSTALL_EXAMPLEDIR "examples/gamepad/keyNavigation")
+
+find_package(Qt6 COMPONENTS Core)
+find_package(Qt6 COMPONENTS Gui)
+find_package(Qt6 COMPONENTS Qml)
+find_package(Qt6 COMPONENTS Quick)
+
+add_qt_gui_executable(keyNavigation
+    main.cpp
+)
+target_link_libraries(keyNavigation PUBLIC
+    Qt::Core
+    Qt::Gui
+    Qt::Qml
+    Qt::Quick
+)
+
+
+# Resources:
+set(qml_resource_files
+    "qml/main.qml"
+)
+
+qt6_add_resources(keyNavigation "qml"
+    PREFIX
+        "/"
+    FILES
+        ${qml_resource_files}
+)
+
+install(TARGETS keyNavigation
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/examples/gamepad/mouseItem/CMakeLists.txt b/examples/gamepad/mouseItem/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..3d75e62b77103dae58689d8c34e9108f8044fcb7
--- /dev/null
+++ b/examples/gamepad/mouseItem/CMakeLists.txt
@@ -0,0 +1,46 @@
+# Generated from mouseItem.pro.
+
+cmake_minimum_required(VERSION 3.14)
+project(mouseItem LANGUAGES CXX)
+
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+set(CMAKE_AUTOUIC ON)
+
+set(INSTALL_EXAMPLEDIR "examples/gamepad/mouseItem")
+
+find_package(Qt6 COMPONENTS Core)
+find_package(Qt6 COMPONENTS Gui)
+find_package(Qt6 COMPONENTS Qml)
+find_package(Qt6 COMPONENTS Quick)
+
+add_qt_gui_executable(mouseItem
+    main.cpp
+)
+target_link_libraries(mouseItem PUBLIC
+    Qt::Core
+    Qt::Gui
+    Qt::Qml
+    Qt::Quick
+)
+
+
+# Resources:
+set(qml_resource_files
+    "qml/main.qml"
+)
+
+qt6_add_resources(mouseItem "qml"
+    PREFIX
+        "/"
+    FILES
+        ${qml_resource_files}
+)
+
+install(TARGETS mouseItem
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/examples/gamepad/quickGamepad/CMakeLists.txt b/examples/gamepad/quickGamepad/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..80d42e5ee2f3cdf2b0743c80c425c1ec745c63f7
--- /dev/null
+++ b/examples/gamepad/quickGamepad/CMakeLists.txt
@@ -0,0 +1,67 @@
+# Generated from quickGamepad.pro.
+
+cmake_minimum_required(VERSION 3.14)
+project(quickGamepad LANGUAGES CXX)
+
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+set(CMAKE_AUTOUIC ON)
+
+set(INSTALL_EXAMPLEDIR "examples/gamepad/quickGamepad")
+
+find_package(Qt6 COMPONENTS Core)
+find_package(Qt6 COMPONENTS Gui)
+find_package(Qt6 COMPONENTS Qml)
+find_package(Qt6 COMPONENTS Quick)
+find_package(Qt6 COMPONENTS Gamepad)
+
+add_qt_gui_executable(quickGamepad
+    main.cpp
+)
+target_link_libraries(quickGamepad PUBLIC
+    Qt::Core
+    Qt::Gamepad
+    Qt::Gui
+    Qt::Qml
+    Qt::Quick
+)
+
+
+# Resources:
+set(qml_resource_files
+    "qml/ButtonImage.qml"
+    "qml/DPad.qml"
+    "qml/JoystickViewer.qml"
+    "qml/LeftThumbstick.qml"
+    "qml/RightThumbstick.qml"
+    "qml/main.qml"
+    "qml/xboxControllerBack.png"
+    "qml/xboxControllerButtonA.png"
+    "qml/xboxControllerButtonB.png"
+    "qml/xboxControllerButtonGuide.png"
+    "qml/xboxControllerButtonX.png"
+    "qml/xboxControllerButtonY.png"
+    "qml/xboxControllerDPad.png"
+    "qml/xboxControllerLeftShoulder.png"
+    "qml/xboxControllerLeftThumbstick.png"
+    "qml/xboxControllerLeftTrigger.png"
+    "qml/xboxControllerRightShoulder.png"
+    "qml/xboxControllerRightThumbstick.png"
+    "qml/xboxControllerRightTrigger.png"
+    "qml/xboxControllerStart.png"
+)
+
+qt6_add_resources(quickGamepad "qml"
+    PREFIX
+        "/"
+    FILES
+        ${qml_resource_files}
+)
+
+install(TARGETS quickGamepad
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/examples/gamepad/simple/CMakeLists.txt b/examples/gamepad/simple/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..7194a65d5330ac3a610dd10673e62ca460de906d
--- /dev/null
+++ b/examples/gamepad/simple/CMakeLists.txt
@@ -0,0 +1,32 @@
+# Generated from simple.pro.
+
+cmake_minimum_required(VERSION 3.14)
+project(simple LANGUAGES CXX)
+
+set(CMAKE_INCLUDE_CURRENT_DIR ON)
+
+set(CMAKE_AUTOMOC ON)
+set(CMAKE_AUTORCC ON)
+set(CMAKE_AUTOUIC ON)
+
+set(INSTALL_EXAMPLEDIR "examples/gamepad/simple")
+
+find_package(Qt6 COMPONENTS Core)
+find_package(Qt6 COMPONENTS Gui)
+find_package(Qt6 COMPONENTS Gamepad)
+
+add_qt_gui_executable(simple
+    gamepadmonitor.cpp gamepadmonitor.h
+    main.cpp
+)
+target_link_libraries(simple PUBLIC
+    Qt::Core
+    Qt::Gamepad
+    Qt::Gui
+)
+
+install(TARGETS simple
+    RUNTIME DESTINATION "${INSTALL_EXAMPLEDIR}"
+    BUNDLE DESTINATION "${INSTALL_EXAMPLEDIR}"
+    LIBRARY DESTINATION "${INSTALL_EXAMPLEDIR}"
+)
diff --git a/src/.prev_CMakeLists.txt b/src/.prev_CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..1b57d6d0ba3a9b117ad2801c9c6c9639c593ddc8
--- /dev/null
+++ b/src/.prev_CMakeLists.txt
@@ -0,0 +1,4 @@
+# Generated from src.pro.
+
+add_subdirectory(gamepad)
+add_subdirectory(plugins)
diff --git a/src/CMakeLists.txt b/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..bc1b22d81b380404d5d9f0e4144933747adbc778
--- /dev/null
+++ b/src/CMakeLists.txt
@@ -0,0 +1,10 @@
+# Generated from src.pro.
+
+add_subdirectory(gamepad)
+add_subdirectory(plugins)
+
+# special case begin
+if (TARGET Qt::Quick)
+    add_subdirectory(imports)
+endif()
+# special case end
diff --git a/src/gamepad/CMakeLists.txt b/src/gamepad/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..01f520c7e256fe6ef6264872b772a13ca702d19d
--- /dev/null
+++ b/src/gamepad/CMakeLists.txt
@@ -0,0 +1,40 @@
+# Generated from gamepad.pro.
+
+#####################################################################
+## Gamepad Module:
+#####################################################################
+
+qt_add_module(Gamepad
+    PLUGIN_TYPES gamepads
+    SOURCES
+        qgamepad.cpp qgamepad.h
+        qgamepadbackend.cpp qgamepadbackend_p.h
+        qgamepadbackendfactory.cpp qgamepadbackendfactory_p.h
+        qgamepadbackendplugin.cpp qgamepadbackendplugin_p.h
+        qgamepadkeynavigation.cpp qgamepadkeynavigation.h
+        qgamepadmanager.cpp qgamepadmanager.h
+        qtgamepadglobal.h
+    DEFINES
+        QT_BUILD_GAMEPAD_LIB
+    LIBRARIES
+        Qt::CorePrivate
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::Gui
+)
+
+if(ANDROID)
+    set_property(TARGET Gamepad APPEND PROPERTY QT_ANDROID_BUNDLED_JAR_DEPENDENCIES
+        jar/QtAndroidGamepad.jar
+    )
+    set_property(TARGET Gamepad APPEND PROPERTY QT_ANDROID_LIB_DEPENDENCIES
+        plugins/gamepads/libplugins_gamepads_androidgamepad.so
+    )
+endif()
+
+#### Keys ignored in scope 1:.:.:gamepad.pro:<TRUE>:
+# ANDROID_FEATURES = "android.hardware.gamepad"
+qt_add_docs(Gamepad
+    doc/qtgamepad.qdocconf
+)
+
diff --git a/src/gamepad/configure.cmake b/src/gamepad/configure.cmake
new file mode 100644
index 0000000000000000000000000000000000000000..206b3b03df4e262d76c42b9aa6e2fd49b0472f90
--- /dev/null
+++ b/src/gamepad/configure.cmake
@@ -0,0 +1,21 @@
+
+
+#### Inputs
+
+
+
+#### Libraries
+
+qt_find_package(WrapSDL2 PROVIDED_TARGETS WrapSDL2::WrapSDL2)
+
+
+#### Tests
+
+
+
+#### Features
+
+qt_feature("sdl2" PRIVATE
+    LABEL "SDL2"
+    CONDITION WrapSDL2_FOUND
+)
diff --git a/src/imports/CMakeLists.txt b/src/imports/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..7259845123b82d9b5429e871f47cec9690a81fd1
--- /dev/null
+++ b/src/imports/CMakeLists.txt
@@ -0,0 +1,3 @@
+# Generated from imports.pro.
+
+add_subdirectory(gamepad)
diff --git a/src/imports/gamepad/CMakeLists.txt b/src/imports/gamepad/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..358c11999ef23420608994492e2c59aadacba61f
--- /dev/null
+++ b/src/imports/gamepad/CMakeLists.txt
@@ -0,0 +1,27 @@
+# Generated from gamepad.pro.
+
+#####################################################################
+## declarative_gamepad Plugin:
+#####################################################################
+
+qt_add_qml_module(declarative_gamepad
+    URI "QtGamepad"
+    VERSION "1.${CMAKE_PROJECT_VERSION_MINOR}"
+    CLASSNAME QGamepadModule
+    SKIP_TYPE_REGISTRATION
+    SOURCES
+        qgamepadmouseitem.cpp qgamepadmouseitem.h
+        qtgamepad.cpp
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::Gamepad
+        Qt::Gui
+        Qt::Qml
+        Qt::Quick
+)
+
+#### Keys ignored in scope 1:.:.:gamepad.pro:<TRUE>:
+# CXX_MODULE = "gamepad"
+# IMPORT_VERSION = "1.$$QT_MINOR_VERSION"
+# OTHER_FILES = "qmldir"
+# TARGETPATH = "QtGamepad"
diff --git a/src/plugins/CMakeLists.txt b/src/plugins/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..5ceab6d78cf5f660dbf6464082c8b40cef671347
--- /dev/null
+++ b/src/plugins/CMakeLists.txt
@@ -0,0 +1,3 @@
+# Generated from plugins.pro.
+
+add_subdirectory(gamepads)
diff --git a/src/plugins/gamepads/CMakeLists.txt b/src/plugins/gamepads/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..22ab69f1807a427ee6b11234c6da2304d3e49bb2
--- /dev/null
+++ b/src/plugins/gamepads/CMakeLists.txt
@@ -0,0 +1,17 @@
+# Generated from gamepads.pro.
+
+if(QT_FEATURE_sdl2)
+    add_subdirectory(sdl2)
+endif()
+if(QT_FEATURE_evdev AND NOT ANDROID)
+    add_subdirectory(evdev)
+endif()
+if(WIN32)
+    add_subdirectory(xinput)
+endif()
+if(APPLE AND NOT APPLE_WATCHOS)
+    add_subdirectory(darwin)
+endif()
+if(ANDROID AND NOT ANDROID_EMBEDDED)
+    add_subdirectory(android)
+endif()
diff --git a/src/plugins/gamepads/android/CMakeLists.txt b/src/plugins/gamepads/android/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..22fe2b6ba2c9448c772cfd2d65cbf44f488e7449
--- /dev/null
+++ b/src/plugins/gamepads/android/CMakeLists.txt
@@ -0,0 +1,4 @@
+# Generated from android.pro.
+
+add_subdirectory(jar)
+add_subdirectory(src)
diff --git a/src/plugins/gamepads/android/jar/.prev_CMakeLists.txt b/src/plugins/gamepads/android/jar/.prev_CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..ed8cb079a94c4aca7c8c29667450b36c211c3811
--- /dev/null
+++ b/src/plugins/gamepads/android/jar/.prev_CMakeLists.txt
@@ -0,0 +1,20 @@
+# Generated from jar.pro.
+
+#####################################################################
+## QtAndroidGamepad Binary:
+#####################################################################
+
+add_qt_executable(QtAndroidGamepad
+    GUI
+    INSTALL_DIRECTORY "${INSTALL_DIRECTORY}/jar"
+    OUTPUT_DIRECTORY "$$MODULE_BASE_OUTDIR/jar"
+    PUBLIC_LIBRARIES
+        Qt::Gui
+)
+
+#### Keys ignored in scope 1:.:.:jar.pro:<TRUE>:
+# API_VERSION = "android-16"
+# JAVACLASSPATH = "$$PWD/src"
+# JAVASOURCES = "$$PWD/src/org/qtproject/qt5/android/gamepad/QtGamepad.java"
+# OTHER_FILES = "$$JAVASOURCES"
+# _LOADED = "qt_build_paths"
diff --git a/src/plugins/gamepads/android/jar/CMakeLists.txt b/src/plugins/gamepads/android/jar/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..17a5a64e9d03f30c387bc720e2ca5d9b3a4c3883
--- /dev/null
+++ b/src/plugins/gamepads/android/jar/CMakeLists.txt
@@ -0,0 +1,18 @@
+# Generated from jar.pro.
+
+qt_get_android_sdk_jar_for_api("android-16" android_sdk)
+
+set(java_sources
+    src/org/qtproject/qt5/android/gamepad/QtGamepad.java
+)
+
+add_jar(QtAndroidGamepad
+    INCLUDE_JARS ${android_sdk}
+    SOURCES ${java_sources}
+)
+
+install_jar(QtAndroidGamepad
+    DESTINATION jar
+    COMPONENT Devel
+)
+
diff --git a/src/plugins/gamepads/android/src/CMakeLists.txt b/src/plugins/gamepads/android/src/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..141b3b6e7ba8dbba16c1e0244e3589fe64e3772f
--- /dev/null
+++ b/src/plugins/gamepads/android/src/CMakeLists.txt
@@ -0,0 +1,23 @@
+# Generated from src.pro.
+
+#####################################################################
+## androidgamepad Plugin:
+#####################################################################
+
+qt_add_plugin(androidgamepad
+    TYPE gamepads
+    CLASS_NAME QAndroidGamepadBackendPlugin
+    SOURCES
+        main.cpp
+        qandroidgamepadbackend.cpp qandroidgamepadbackend_p.h
+    LIBRARIES
+        Qt::CorePrivate
+        Qt::GamepadPrivate
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::Gamepad
+        Qt::Gui
+)
+
+#### Keys ignored in scope 1:.:.:src.pro:<TRUE>:
+# DISTFILES = "android.json"
diff --git a/src/plugins/gamepads/darwin/CMakeLists.txt b/src/plugins/gamepads/darwin/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..b608b0eab4b3054efc824c5f685c296c1fa37a38
--- /dev/null
+++ b/src/plugins/gamepads/darwin/CMakeLists.txt
@@ -0,0 +1,25 @@
+# Generated from darwin.pro.
+
+#####################################################################
+## darwingamepad Plugin:
+#####################################################################
+
+qt_add_plugin(darwingamepad
+    TYPE gamepads
+    CLASS_NAME QDarwinGamepadBackendPlugin
+    SOURCES
+        main.cpp
+        qdarwingamepadbackend.mm qdarwingamepadbackend_p.h
+    LIBRARIES
+        Qt::GamepadPrivate
+    PUBLIC_LIBRARIES
+        ${FWFoundation}
+        ${FWGameController}
+        Qt::Core
+        Qt::Gamepad
+        Qt::Gui
+)
+
+#### Keys ignored in scope 1:.:.:darwin.pro:<TRUE>:
+# OTHER_FILES = "darwin.json"
+# PLUGIN_EXTENDS = "gamepad"
diff --git a/src/plugins/gamepads/evdev/CMakeLists.txt b/src/plugins/gamepads/evdev/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..36eae366ae1f99f662ae9fdef1821e54383cf28a
--- /dev/null
+++ b/src/plugins/gamepads/evdev/CMakeLists.txt
@@ -0,0 +1,25 @@
+# Generated from evdev.pro.
+
+#####################################################################
+## evdevgamepad Plugin:
+#####################################################################
+
+qt_add_plugin(evdevgamepad
+    TYPE gamepads
+    CLASS_NAME QEvdevGamepadBackendPlugin
+    SOURCES
+        main.cpp
+        qevdevgamepadbackend.cpp qevdevgamepadbackend_p.h
+    LIBRARIES
+        Qt::CorePrivate
+        Qt::DeviceDiscoverySupportPrivate
+        Qt::GamepadPrivate
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::DeviceDiscoverySupport
+        Qt::Gamepad
+        Qt::Gui
+)
+
+#### Keys ignored in scope 1:.:.:evdev.pro:<TRUE>:
+# OTHER_FILES = "evdev.json"
diff --git a/src/plugins/gamepads/sdl2/CMakeLists.txt b/src/plugins/gamepads/sdl2/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..28f79375cc1d127e4f0bb92f29c94bfb414a187b
--- /dev/null
+++ b/src/plugins/gamepads/sdl2/CMakeLists.txt
@@ -0,0 +1,23 @@
+# Generated from sdl2.pro.
+
+#####################################################################
+## sdl2gamepad Plugin:
+#####################################################################
+
+qt_add_plugin(sdl2gamepad
+    TYPE gamepads
+    CLASS_NAME QSdl2GamepadBackendPlugin
+    SOURCES
+        main.cpp
+        qsdlgamepadbackend.cpp qsdlgamepadbackend_p.h
+    LIBRARIES
+        Qt::GamepadPrivate
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::Gamepad
+        Qt::Gui
+        WrapSDL2::WrapSDL2
+)
+
+#### Keys ignored in scope 1:.:.:sdl2.pro:<TRUE>:
+# OTHER_FILES = "sdl2.json"
diff --git a/src/plugins/gamepads/xinput/CMakeLists.txt b/src/plugins/gamepads/xinput/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..de12c01e89e6e5e6f0bf4a6af2c394a2923847df
--- /dev/null
+++ b/src/plugins/gamepads/xinput/CMakeLists.txt
@@ -0,0 +1,22 @@
+# Generated from xinput.pro.
+
+#####################################################################
+## xinputgamepad Plugin:
+#####################################################################
+
+qt_add_plugin(xinputgamepad
+    TYPE gamepads
+    CLASS_NAME QXInputGamepadBackendPlugin
+    SOURCES
+        main.cpp
+        qxinputgamepadbackend.cpp qxinputgamepadbackend_p.h
+    LIBRARIES
+        Qt::GamepadPrivate
+    PUBLIC_LIBRARIES
+        Qt::Core
+        Qt::Gamepad
+        Qt::Gui
+)
+
+#### Keys ignored in scope 1:.:.:xinput.pro:<TRUE>:
+# OTHER_FILES = "xinput.json"
diff --git a/tests/.prev_CMakeLists.txt b/tests/.prev_CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..c96e5981958e6d0d33d08b4ab29503046949674b
--- /dev/null
+++ b/tests/.prev_CMakeLists.txt
@@ -0,0 +1,10 @@
+# Generated from tests.pro.
+
+if(NOT TARGET Qt::Test)
+    cmake_minimum_required(VERSION 3.15.0)
+    project(QtGamepadTests VERSION 6.0.0 LANGUAGES C CXX)
+    find_package(Qt6 ${PROJECT_VERSION} REQUIRED COMPONENTS BuildInternals Core SET_ME_TO_SOMETHING_USEFUL)
+    find_package(Qt6 ${PROJECT_VERSION} OPTIONAL_COMPONENTS SET_ME_TO_SOMETHING_USEFUL)
+    qt_set_up_standalone_tests_build()
+endif()
+qt_build_tests()
diff --git a/tests/CMakeLists.txt b/tests/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..fe83264c8ceb3dd67334e26f0849e90e38459f51
--- /dev/null
+++ b/tests/CMakeLists.txt
@@ -0,0 +1,9 @@
+# Generated from tests.pro.
+
+if(NOT TARGET Qt::Test)
+    cmake_minimum_required(VERSION 3.15.0)
+    project(QtGamepadTests VERSION 6.0.0 LANGUAGES C CXX)
+    find_package(Qt6 ${PROJECT_VERSION} REQUIRED COMPONENTS BuildInternals Core Test Gui) # special case
+    qt_set_up_standalone_tests_build()
+endif()
+qt_build_tests()
diff --git a/tests/auto/CMakeLists.txt b/tests/auto/CMakeLists.txt
new file mode 100644
index 0000000000000000000000000000000000000000..8348667d8d5753ef537dce1b85fa18d94d957caa
--- /dev/null
+++ b/tests/auto/CMakeLists.txt
@@ -0,0 +1,2 @@
+# Generated from auto.pro.
+
